package com.logicbig.example;

import javax.servlet.ServletException;
import javax.servlet.annotation.WebServlet;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;
import java.io.IOException;
import java.security.Principal;

@WebServlet(name = "logoutServlet", urlPatterns = {"/logout"})
public class LogoutServlet extends HttpServlet {
    @Override
    protected void doGet(HttpServletRequest req, HttpServletResponse resp)
            throws ServletException, IOException {
        System.out.println("logging out");
        req.logout();
        Principal principal = req.getUserPrincipal();
        if (principal != null) {
            throw new RuntimeException("Cannot log out the user");
        }

        HttpSession session = req.getSession(false);
        if (session != null) {
            //invalidate session specially if we have added some user specific info
            session.invalidate();
        }

        Object msg = req.getParameter("msg");
        if ("onTimeOut".equals(msg)) {
            LoginHandlerServlet.forwardToLogin(req, resp, "Session timeout.");
            return;
        }

        resp.sendRedirect("/");
    }
}